<?php
include_once ROOTPATH."/../expressoMail1_2/inc/class.imap_functions.inc.php";

class Helpers {    

/**
 * LABEL
 */ 
	//labeled:after.find
	public function deepnessLabeleds( &$uri , &$result , &$criteria , $original ){                

		if(isset($original['criteria']['deepness']))
		{
			foreach ($result as $i => $v)
			{
				if(isset($v['labelId']))
				{
					$labels = Controller::find( array( 'concept' => 'label' ) , false, array( 'filter' => array('=', 'id'  ,  $v['labelId']) ));     
					$result[$i]['label'] = $labels[0];
				}              

			}
		}

		return $result;
	}
	
	/**
	 * Método a ser chamado na exclusão de um label, procedendo com a
	 * desvinculação deste label com todas as mensagens a que estava vinculado
	 */
	//label:before.delete
	public function clearAllLabeledsOfLabel( &$uri , &$result , &$criteria , $original ){
		
		$labeleds = Controller::find( array( 'concept' => 'labeled' ) , false, array( 'filter' => array('=', 'labelId'  ,  $uri['id']) ));
		if (empty($labeleds))
			return;
		
		$labeledsIds = array();
		foreach ($labeleds as $e) {
				$labeledsIds[] = $e['id'];
		}
		
		Controller::delete( array( 'concept' => 'labeled' ), false, array( 'filter' => array( 'IN', 'id', $labeledsIds )) );

		//return $result;
	}
	/**
	 * Método a ser chamado ao listar os labeleds, uma vez que as funções de IMAP do PHP não são capazes de 
	 * obter a lista de todos os labels e nem são capazes de obter os labels de uma dada mensagem
	 */
	//labeled:before.find
	public function makeLabelListFilter( &$uri , &$result , &$criteria , $original ){

		if (!isset($criteria['filter']) || !self::in_arrayr('labelId', $criteria['filter'])) {
			$labels = Controller::find( array( 'concept' => 'label' ) );

			$list = array();
			foreach ($labels as $label)
				$list[] = $label['id'];
				
			$filter = array( 'IN' , 'labelId' , $list );
			
			if (isset($criteria['filter']) && $criteria['filter']!=NULL && count($criteria['filter']) != 0)
				$criteria['filter'] = array( 'AND', $criteria['filter'], $filter );
			else
				$criteria['filter'] =  $filter;
		}
	}
	
	//label:before.create
	public function verifyNameLabel(&$uri , &$params , &$criteria , $original){
		$nameLabel = $params['name'];
		$Labels = Controller::find(array('concept' => 'label'), false, array('filter' => array('i=', 'name', $nameLabel) ));
		if($Labels){
			Throw new Exception('Já existe um marcador com esse nome.');
		}
	}
		
	public static function in_arrayr($needle, $haystack) {
		//if(!is_array($haystack)) return false;
		
		foreach ($haystack as $v) {
				if ($needle == $v) return true;
				elseif (is_array($v)) return self::in_arrayr($needle, $v);
		}
		return false;
	} 
	
/**
 * FOLLOWUPFLAG
 */ 
 
	//followupflag:before.find 
	public function addDefaultElementsFilter (&$uri , &$params , &$criteria , $original ){ 
		//if (!self::in_arrayr('id', $criteria['filter'])) { 
			$defaultsFilter = array( 'IN' , 'id' , array('1','2','3','4','5','6') ); 

			if (isset($criteria['filter']) && $criteria['filter']!=NULL && count($criteria['filter']) != 0) 
				$criteria['filter'] = array( 'OR', $criteria['filter'], $defaultsFilter ); 
			else 
				$criteria['filter'] =  $defaultsFilter; 
		//} 
	}

	//Remove as dependencias de uma followupflag 
	public function clearAllFlaggedOfFollowupflag( &$uri , &$result , &$criteria , $original ){
		//remove apenas se vier o id da Followupflag
		if(isset($uri['id'])) {
			Controller::deleteALL(array('concept' => 'followupflagged'), null , array('filter' => array('=' , 'followupflagId' , $uri['id'])));
		
		}
	}

	//followupflagged:PostgreSQL.before.delete
	public function doImapDelete( &$uri , &$params , &$criteria , $original ) {
	
		$imap_uri = $uri;
		$imap_uri['service'] = 'Imap';
		list($messageId, $uri['id']) = explode('#', $uri['id']);

		$result = Controller::delete($imap_uri, $params, $imap_criteria);

		if (!$result)
			return false;
	}
		
	//followupflagged:PostgreSQL.before.create
	public function doImapCreate( &$uri , &$params , &$criteria , $original ) {	
		
		$imap_uri = $uri;
		$imap_uri['service'] = 'Imap';

		$params = Controller::create($imap_uri, $params);
		
		if (!$params)
			return false;	
	}
	
	//followupflagged:PostgreSQL.after.read
	public function doImapRead( &$uri , &$result , &$criteria , $original ) {

		if ($reusult) {
			$imap_result = Controller::read(
				array('concept' => 'followupflagged', 'service' => 'Imap'), 
				false, 
				array('filter' => array('=', 'messageId', $result['messageId']))
			);
		}

		if (!$imap_result) {
			/**
			 * TODO - deletar do banco se não existe no imap 
			 */
			 return false;
		}
		
		$result = $result + $imap_result;
		
		return $result;
	}
	
	
	/**
	 * Método a ser chamado ao listar os sinalizadores, uma vez que as funções de IMAP do PHP não são capazes de 
	 * obter a lista de todos os sinalizadores e nem são capazes de obter os sinalizadores de uma dada mensagem
	 */
	//followupflagged:PostgreSQL.after.find
	public function doImapFind( &$uri , &$result , &$criteria , $original ){

		$imap_uri = $uri;
		$imap_uri['service'] = 'Imap';
		$imap_result = Controller::find($imap_uri, false, $original['criteria']);

		/**
		 * Mescla os dados vindos do PostgreSQL com os dados vindos do Imap
		 */
		$merge_result = array ();
		foreach ($imap_result as $ir) {
		
			foreach($result as $r) {
				if ($r['messageId'] == $ir['messageId']) {			
					$merge_result[] = $r + $ir;
					break;
				}
			}
		}
			
		return $merge_result;
	}

	//followupflagged:PostgreSQL.before.find
	public function reFilterFind (&$uri , &$params , &$criteria , $original ){
		/**
		 * Se p filtor incluir atributos da mensagem que o banco de dados não conhece,  
		 * deve-se obter os messageId dos itens do resultado e passálos num novo filtro
		 * que o banco conheça
		 */
		if (self::in_arrayr('messageNumber', $criteria) || self::in_arrayr('folderName', $criteria)) {
			$result = Controller::find(array('concept' => 'message'), array('messageId'), array('filter' => $criteria['filter']));
			$idList = array();
			foreach ($result as $message)
				$idList[] = $message['messageId'];
				
			$filter = array( 'IN' , 'messageId' , $idList );

			$criteria['filter'] =  $filter;
		}	
	}	

}

?>
